
model large

.code

public _prog_dma
public _reset_dma
public _dma_channel
public _dmabaseadd
public _dmapagereg
public _dmalenght
public _dma_mode

_dma_channel     db      1
_dmabaseadd      dw      2
_dmapagereg      dw      83h
_dmalenght       dw      3
_dma_mode        db      58h

;===============================
; Procedura ustawia transfer DMA
; w kanaach 0-3

_prog_dma        proc far
arg page : byte,ofs : word,lenght : word
        push    bp
        mov     bp,sp
        mov     al,4
        add     al,[_dma_channel]
        out     0Ah,al
        xor     al,al
        out     0Ch,al
        mov     al,[_dma_mode]
        add     al,[_dma_channel]
        out     0Bh,al
        mov     dx,[_dmabaseadd]
        mov     ax,[ofs]
        out     dx,al
        mov     al,ah
        out     dx,al
        inc     dx
        mov     ax,[lenght]
        out     dx,al
        mov     al,ah
        out     dx,al
        mov     al,[page]
        mov     dx,[_dmapagereg]
        out     dx,al
        mov     al,[_dma_channel]
        out     0Ah,al
        pop     bp
        ret
endp

;===============================
; Procedura zeruje kana DMA 0-3

_reset_dma       proc   far
        mov     dx,0ah
        mov     ax,4
        add     al,[_dma_channel]
        out     dx,ax
        ret
endp

end
