
p286
model large

public _sb_init
public _dsp_out
public _dsp_in

.code

sb_port        dw      220h   ; adres bazowy karty SB

;==============================================
; Wysanie danej/komendy do ukadu DSP karty SB

_dsp_out proc far
arg data : byte
        push    bp
        mov     bp,sp
        mov     dx,[sb_port]
        add     dx,0ch
dsp_out_1:
        in      al,dx
        test    al,80h
        jne     dsp_out_1
        mov     al,[data]
        out     dx,al
        pop     bp
        ret
endp

;================================
; Inicjalizacja karty SB

_sb_init proc far
arg new_sb_port : word
        push    bp
        mov     bp,sp
        mov     al,1
        mov     dx,[new_sb_port]
        add     dx,6
        out     dx,al
        in      al,dx
        in      al,dx
        in      al,dx
        in      al,dx
        xor     al,al
        out     dx,al
        add     dx,4
        mov     cx,100
sb_init_1:
        in      al,dx
        cmp     al,0AAh
        je      sb_init_2
        loop    sb_init_1
        mov     ax,1
        pop     bp
        ret
sb_init_2:
        mov     ax,[new_sb_port]
        mov     [sb_port],ax
        xor     ax,ax
        pop     bp
        ret
endp

;===================================
; Odczyt danej z ukadu DSP karty SB

_dsp_in proc far
        push    bp
        mov     bp,sp
        mov     dx,[sb_port]
        add     dx,0eh
        sub     al,al
dsp_in_1:
        in      al,dx
        test    al,80h
        je      dsp_in_1
        sub     dx,04
        in      al,dx
        pop     bp
        ret
endp

end
